<?php
/**
 * rvsp_formato_factura actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage rvsp_formato_factura
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class rvsp_formato_facturaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'RVSP_FORMATO_FACTURA_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'RVSP_FORMATO_FACTURA_V' =>
        array(
            'id_formato_factura' => 'id_formato_factura',
            'id_mae_ter' => 'id_mae_ter',
            'no_factura' => 'no_factura',
            'fecha_emision' => 'fecha_emision',
            'fecha_vencimiento' => 'fecha_vencimiento',
            'vencimiento' => 'vencimiento',
            'cosumo_inicial' => 'cosumo_inicial',
            'cosumo_final' => 'cosumo_final',
            'valor' => 'valor',
            'valor_intereses' => 'valor_intereses',
            'subtotal_total_factura'=>'subtotal_total_factura',
            'iva_total_factura'=>'iva_total_factura',
            'id_tipo_servicio' => 'id_tipo_servicio',
            'id_estado' => 'id_estado',
            'usuario_log' => 'usuario_log',
            'fecha_log' => 'fecha_log',
            'id_cen_op' => 'id_cen_op',
            'sede_recepcion' => 'sede_recepcion',
            'estado_desc' => 'estado_desc',
            'adjunto' => 'adjunto',
            'fecha_ini_periodo' => 'fecha_ini_periodo',
            'fecha_fin_periodo' => 'fecha_fin_periodo',
            'no_referencia' => 'no_referencia',
            'nombre_proveedor' => 'nombre_proveedor',
            'documento_proveedor' => 'documento_proveedor',
            'no_cliente' => 'no_cliente',
            'numero_radicado' => 'numero_radicado',
            'pendiente' => 'pendiente',
            'firmado' => 'firmado',
            'autorizado' => 'autorizado',
            'radicado' => 'radicado',
            'rechazado' => 'rechazado'            
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * EJEMPLO: 'titular' => array('NULL' => array('titular')),
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'RVSP_FORMATO_FACTURA_V' => array(
            'id_formato_factura,a' => array('!=' => array(-1)),
            'id_formato_factura,b' => array('=' => array('id_formato_factura')),
            'fecha_emision' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'fecha_ini_periodo' => array('BETWEENFECHA' => array('fecha_emision_ini', 'fecha_emision_fin')),
            'vencimiento' => array('=' => array('vencimiento')),
            'id_tipo_servicio' => array('=' => array('id_tipo_servicio')),
            'id_estado' => array('IN' => array('id_estado')),
            'id_cen_op' => array('=' => array('id_cen_op')),
            'id_mae_ter' => array('=' => array('id_mae_ter')),
            'no_factura' => array('LIKEALLPLUS' => array('no_factura')),//no_referencia
            'no_referencia' => array('LIKEALLPLUS' => array('no_referencia')),
            'numero_radicado' => array('IN' => array('numero_radicado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
           
    ); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'fecha_emision', 'id_tipo_servicio'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_formato_factura'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_formato_factura'); //llave primaria
    protected $field_names = array('id_mae_ter', 'no_factura', 'fecha_emision', 'fecha_vencimiento','vencimiento',
        'valor', 'valor_intereses','subtotal_total_factura','iva_total_factura', 'id_tipo_servicio', 'id_estado', 'usuario_log', 'fecha_log', 'id_cen_op', 'sede_recepcion', 'adjunto',
        'fecha_ini_periodo', 'fecha_fin_periodo', 'no_referencia', 'no_cliente','cosumo_inicial','cosumo_final'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'RVSP_FORMATO_FACTURA'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_formato_factura'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        $logger = sfContext::getInstance()->getLogger();
        //valor por defecto
        $errors = null;

        $logger->info("Entro a validateAdd");
        
        $nofactura = $request['no_factura'];
        
        $valor =$request['valor'];

        //Valida que el valor de la novedad no supere el valor de aporte colciencias mas otros desembolsos
        //sentencia sql
        $sql = <<<EOD
select
no_factura as no_factura
from rvsp_formato_factura cont
where
cont.no_factura = '$nofactura'
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0){
            $errors['mensaje'] = "No. de factura ya existe, por favor ingresar nuevamente otro numero.";
                $errors['servicio'] = "rvsp_formato_factura";
                $logger->info("No. de factura ya existe, por favor ingresar nuevamente otro numero.");
            
        }
        
        if($valor<=0){
            
            
            $errors['mensaje'] = "Ingresar un valor mayor a cero.";
                $errors['servicio'] = "rvsp_formato_factura";
                $logger->info("Ingresar un valor mayor a cero.");
            
        }
        /*
         * Variables request
         */


        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {
        $logger = sfContext::getInstance()->getLogger();
        //valor por defecto
        $errors = null;
        
          /*
             * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
             */
            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                //echo $routeName . "\n";
                if ('entidad_cliente' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $entidadCliente = $value;
                        }
                    }
                }
                if ('entidad_nombre' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $entidadNombre = $value;
                        }
                    }
                }
                if ('correoEnvio' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $correoEnvio = $value;
                        }
                    }
                }
                
                $int++;
            }
        
        
        if(isset($request['bandera'])&&isset($request['id_estado'])&&isset($request['id_formato_factura'])){
            
                 
        $id_estado = $request['id_estado'];
        $id_formato_factura = $request['id_formato_factura']; 
        $usuario_estado = $request['username'];
         
          $observaciones_estado = '';
            if (isset($request['observaciones'])) {
                $observaciones_estado = $request['observaciones'];
            }
            
             $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {
                
                $sql = <<<EOD
                 
UPDATE RVSP_FORMATO_FACTURA
SET  ID_ESTADO = $id_estado
WHERE id_formato_factura = $id_formato_factura
EOD;
                $this->conn->execute($sql);
                //COMMIT DE TODAS LAS TRANSACCIONES
                
                if($id_estado==9){
                      $this->logMessage("RECHAZAR");
                    //insertamos el registro en la tabla RVSP_FORMATO_FACTURA_ESTADO
                    $sql = <<<EOD
insert into RVSP_FORMATO_FACTURA_ESTADO(id_formato_factura,id_estado,fecha_log,usuario_log,observacion)
    VALUES($id_formato_factura,9,SYSDATE,'$usuario_estado','$observaciones_estado')
EOD;
                    $this->conn->execute($sql);
                   

                    
                    
                    
                    
                }
                
                
                
                if($id_estado==5){
                     $this->logMessage("APROBAR");
                    //insertamos el registro en la tabla RVSP_FORMATO_FACTURA_ESTADO
                    $sql = <<<EOD
insert into RVSP_FORMATO_FACTURA_ESTADO(id_formato_factura,id_estado,fecha_log,usuario_log,observacion)
    VALUES($id_formato_factura,5,SYSDATE,'$usuario_estado','$observaciones_estado')
EOD;
                    $this->conn->execute($sql);
                      $this->logMessage("Envio correo");
                    //Consulta datos envio correo
                    //Sql
                    $sql = <<<EOD
select 
  tab0.id_formato_factura,
  tab0.no_factura as no_factura,  
  tab0.adjunto as adjunto,    
  tab0.fecha_emision as fecha_emision,    
  tab0.DOCUMENTO_PROVEEDOR as num_doc,
  tab0.NOMBRE_PROVEEDOR,
  --tab0.EMAIL_PROVEEDOR,
  '$correoEnvio' as email_envio,
  --'Observacion: '||tab0.OBS_AUTorizado as mensaje_extra,
  '' as mensaje_extra,
  '' as mensaje_firma,
  tab0.documento_firma as num_doc_env,
tab0.vencimiento,                            
  1 as id_tipo_doc_env,
  tab0.nombre_firma as razon_social_env,
  tab0.email_firma as correo_env,
  --Datos Supervisor centro de operaciones
  nvl(tab0.documento_supervisor_sede,'') as num_doc_sup,
  1 as id_tipo_doc_sup,
  nvl(tab0.nombre_supervisor_sede,'') as razon_soc_sup,
  nvl(tab0.email_supervisor_sede,'') as correo_sup,
  '' as mensaje_extra_sup
from 
rvsp_formato_factura_v tab0 
where tab0.id_formato_factura = $id_formato_factura 
EOD;
                    //Ejecutar SQL
                    $records = CN_TABLE::executeSQL($sql);
                    
                    $this->logMessage("Envio correo");
                
               if (count($records) > 0){
                   
                   
                   
                    //ENVIAMOS CORREO A terceros
                        //Sql para traer los correos de terceros de la tabla correspondiente
                        $sql = <<<EOD
        SELECT NUM_DOC,
       NOMBRES,
       APELLIDOS,
       ESTADO,
       EMAIL
FROM RVSP_CORREOS_APROBAR WHERE ESTADO=1
EOD;
                        $this->logMessage('SQL '.$sql);
                        //Ejecutar SQL
                        $rec = CN_TABLE::executeSQL($sql);
                   
                        if(count($rec)>0){
                            foreach ($rec as $key => $value){
                                 $report_params = $records[0];
                        
                        $num_doc = $records[0]['num_doc'];
                        $no_factura = $records[0]['no_factura'];
                        //Ejemplo de la persona que se envia el correo:
                        //123;1;pepito perez;correo@gmal.com
                        $num_doc_env = $value['num_doc'];
                        $id_tipo_doc_env = 1;//$records[0]['id_tipo_doc_env'];
                        $razon_social_env = $value['nombres'].' '.$value['apellidos'];
                        $correo_env = $value['email'];
                        $parts = explode('-', $records[0]['fecha_emision']);
                        
                        $fecha_emision = $parts[0];

                        $datos_usuario = array(
                            '0' => $num_doc_env . ';' . $id_tipo_doc_env . ';' . $razon_social_env . ';' . $correo_env
                        );
                        $subject = "Aprobado - Factura de Servicios Publicos No: ".$no_factura;
                        
                        
                        $report_params['mensaje'] =  "Se informa que ha sido aprobada por Financiera para pago la factura con número: ".$no_factura." del año ".$fecha_emision.".";
                        $currentUri = '';
                        $ruta = '';
                        $adjunto = false;
                        $progress_key = $request['comando'] . $request['username'];
                        $array_adjuntos = array();
                        $entidad_cliente = $entidadCliente;
                        $entidad_nombre = $entidadNombre;
                        $addAddress = true;

                        

                        CN_TABLE::envioCorreo($report_params, $datos_usuario, $subject, $currentUri, $ruta, $adjunto, $progress_key, $array_adjuntos, $entidad_cliente, $entidad_nombre, $addAddress);

                                
                                
                                
                            }
                           

                        
                            
                        }
                         

                        
                    }
                    
                }
                
                
                
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
            
                        $errors['mensaje'] = "Realizado";
                $errors['servicio'] = "rvsp_formato_factura";
                $logger->info("Realizado.");
            
            
            
        }
        
        
        
        
        if(isset($request['bandera'])&&isset($request['fecha_emision_fin'])&&isset($request['fecha_emision_ini'])&&isset($request['observaciones'])){
        $observa =$request['observaciones'];
        $fecha_inicial = $request['fecha_emision_ini'];
        $fecha_final = $request['fecha_emision_fin'];    
            
             $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {
                
                $sql = <<<EOD
                 
    UPDATE RVSP_FORMATO_FACTURA
   SET  ID_ESTADO = 5
WHERE fecha_emision BETWEEN to_date('$fecha_inicial', 'yyyy-mm-dd')
AND to_date('$fecha_final', 'yyyy-mm-dd')
EOD;
                $this->conn->execute($sql);
                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
            
                        $errors['mensaje'] = "Aprobados";
                $errors['servicio'] = "rvsp_formato_factura";
                $logger->info("Aprobados.");
            
            
            
        }else{
            
            
        /*
         *  Validar la operación, ya sea por SQL
         */
            if(isset($request['valor'])){
                 $valor =$request['valor'];
            
                    if($valor<=0){


                        $errors['mensaje'] = "Ingrese un valor mayor a cero.";
                            $errors['servicio'] = "rvsp_formato_factura";
                            $logger->info("Ingresar un valor mayor a cero.");

                    }
                
            }
           
            
            
            
        }
        
        

        
        
        
        
        /*
         *  Generar errores en $errors
         */

        //VALIDAR CORREO


        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['username'];
            $request['fecha_log'] = CN_TABLE::fechaSistema();
        }

        //accion update
        if ($Action == "UPDATE") {
            
          
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        
        
        /*
             * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
             */
            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                //echo $routeName . "\n";
                if ('entidad_cliente' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $entidadCliente = $value;
                        }
                    }
                }
                if ('entidad_nombre' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $entidadNombre = $value;
                        }
                    }
                }
                if ('correoEnvio' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $correoEnvio = $value;
                        }
                    }
                }
                
                $int++;
            }

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {
                $id_formato_factura = $list_data_post[0]['id_formato_factura'];
                $usuario_estado = $request['username'];
                $observaciones_estado = '';
                $sql = <<<EOD
    insert into RVSP_FORMATO_FACTURA_ESTADO(id_formato_factura,id_estado,fecha_log,usuario_log,observacion)
    VALUES($id_formato_factura,1,SYSDATE,'$usuario_estado','$observaciones_estado')
EOD;
                $this->conn->execute($sql);
                //COMMIT DE TODAS LAS TRANSACCIONES
                
                 $this->logMessage("Envio correo");
                    //Consulta datos envio correo
                    //Sql
                    $sql = <<<EOD
select 
  tab0.id_formato_factura,
  tab0.no_factura as no_factura,  
  tab0.adjunto as adjunto,    
  tab0.fecha_emision as fecha_emision,    
  tab0.DOCUMENTO_PROVEEDOR as num_doc,
  tab0.NOMBRE_PROVEEDOR,
  --tab0.EMAIL_PROVEEDOR,
  '$correoEnvio' as email_envio,
  --'Observacion: '||tab0.OBS_AUTorizado as mensaje_extra,
  '' as mensaje_extra,
  '' as mensaje_firma,
  tab0.documento_firma as num_doc_env,
tab0.vencimiento,                            
  1 as id_tipo_doc_env,
  tab0.nombre_firma as razon_social_env,
  tab0.email_firma as correo_env,
  --Datos Supervisor centro de operaciones
  nvl(tab0.documento_supervisor_sede,'') as num_doc_sup,
  1 as id_tipo_doc_sup,
  nvl(tab0.nombre_supervisor_sede,'') as razon_soc_sup,
  nvl(tab0.email_supervisor_sede,'') as correo_sup,
  '' as mensaje_extra_sup
from 
rvsp_formato_factura_v tab0 
where tab0.id_formato_factura = $id_formato_factura 
EOD;
                    //Ejecutar SQL
                    $records = CN_TABLE::executeSQL($sql);
                    
                    $this->logMessage("Envio correo");
                
               if (count($records) > 0&&$records[0]['vencimiento']==1){
                   
                        //ENVIAMOS CORREO A terceros
                        //Sql para traer los correos de terceros de la tabla correspondiente
                        $sql = <<<EOD
        SELECT NUM_DOC,
       NOMBRES,
       APELLIDOS,
       ESTADO,
       EMAIL
FROM RVSP_CORREOS_VENI WHERE ESTADO=1
EOD;
                        $this->logMessage('SQL '.$sql);
                        //Ejecutar SQL
                        $rec = CN_TABLE::executeSQL($sql);
                   
                        if(count($rec)>0){
                            foreach ($rec as $key => $value){
                                  $report_params = $records[0];
                        
                        $num_doc = $records[0]['num_doc'];
                        $no_factura = $records[0]['no_factura'];
                        //Ejemplo de la persona que se envia el correo:
                        //123;1;pepito perez;correo@gmal.com
                        $num_doc_env = $value['num_doc'];
                        $id_tipo_doc_env = 1;// $records[0]['id_tipo_doc_env'];
                        $razon_social_env = $value['nombres']. ' '.$value['apellidos'];
                        $correo_env = $value['email'];
                        $parts = explode('-', $records[0]['fecha_emision']);
                        
                        $fecha_emision = $parts[0];

                        $datos_usuario = array(
                            '0' => $num_doc_env . ';' . $id_tipo_doc_env . ';' . $razon_social_env . ';' . $correo_env
                        );
                        $subject = "ALERTA VENCIMIENTO INMEDIATO - Factura de Servicios Publicos No: ".$no_factura;
                        
                        
                        $report_params['mensaje'] =  "Se informa que se registro la factura No.".$no_factura.", con fecha de vencimiento inmediato.
                            Verificar en el módulo de Servicios Publicos.";
                        $currentUri = '';
                        $ruta = '';
                        $adjunto = false;
                        $progress_key = $request['comando'] . $request['username'];
                        $array_adjuntos = array();
                        $entidad_cliente = $entidadCliente;
                        $entidad_nombre = $entidadNombre;
                        $addAddress = true;

                        

                        CN_TABLE::envioCorreo($report_params, $datos_usuario, $subject, $currentUri, $ruta, $adjunto, $progress_key, $array_adjuntos, $entidad_cliente, $entidad_nombre, $addAddress);

                                
                                
                                
                            }
                        }
                       

                        

                        
                    }
                   

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
